(function($) {
$.fn.acmsColorPicker = function(options) {
    var defaults = {
            palette: [
                'ffffff', 'ffccc9', 'ffce93', 'fffc9e', 'ffffc7', '9aff99', '96fffb', 'cdffff', 'cbcefb',
                'cfcfcf', 'fd6864', 'fe996b', 'fffe65', 'fcff2f', '67fd9a', '38fff8', '68fdff', '9698ed',
                'c0c0c0', 'fe0000', 'f8a102', 'ffcc67', 'f8ff00', '34ff34', '68cbd0', '34cdf9', '6665cd',
                '9b9b9b', 'cb0000', 'f56b00', 'ffcb2f', 'ffc702', '32cb00', '00d2cb', '3166ff', '6434fc',
                '656565', '9a0000', 'ce6301', 'cd9934', '999903', '009901', '329a9d', '3531ff', '6200c9',
                '343434', '680100', '963400', '986536', '646809', '036400', '34696d', '00009b', '303498',
                '000000', '330001', '643403', '663234', '343300', '013300', '003532', '010066', '340096'
            ],
            r      : null,
            g      : null,
            b      : null,
            sample : null
        },
        settings = $.extend({}, defaults, options);

    var i = 0, iz = settings.palette.length, color,
        select = '<div id="js_colorPalette">',
        $pallete, that = this;

    for (; i<iz; i++) {
        color = settings.palette[i];
        select += '<a style="background-color: #'+color+'">&nbsp;</a>';
    }
    select += '</div>';

    $pallete = $(select);
    $('a', $pallete).bind('click', function() {
        var hex_rgb = $(this).css('background-color'),
            r, g, b;
        if (hex_rgb.match(/^rgb\((\d+),\s?(\d+),\s?(\d+)\)$/)) {
            r = RegExp.$1;
            g = RegExp.$2;
            b = RegExp.$3;
        }
        else if (hex_rgb.match(/^#(\w+)$/)) {
            r = parseInt(hex_rgb.substr(1, 2), 16);
            g = parseInt(hex_rgb.substr(3, 2), 16);
            b = parseInt(hex_rgb.substr(5, 2), 16);
        }
        $(settings.r).val(r);
        $(settings.g).val(g);
        $(settings.b).val(b);
        $(that).css('background-color', hex_rgb);

        $pallete.hide();
    });
    
    this.each(function() {
        var that  = this,
            $self = $(that);

        $self.bind('click', function() {
            var pos = $self.position(),
                x   = pos.left + $self.width(),
                y   = pos.top  + $self.height();

            $self.after($pallete);
            $pallete.css({
                position: 'absolute',
                left    : x,
                top     : y
            });
            $pallete.show();
            return false;
        });
    });
};
})(jQuery);